#include "testlib.h"
#include <bitset>

using namespace std;

const int N = 4e5;

const int Q = 21;

set<int> pw;

void validateAnswer(int k, InStream& inf, const vector<int>& a) {
  vector<int> ans(k);
  for (int i = 0; i < k; i++) {
    ans[i] = inf.readInt(-(1 << 20), 1 << 20);
    if (!pw.count(ans[i])) {
      inf.quitf(_wa, "%d is either not a power of two or too large to be true", ans[i]);
    }
  }
  bitset<2 << Q> bs;
  bs.set(0, true);
  for (int i : ans) {
    if (i > 0) {
      bs |= bs << i;
    }
  }
  for (int i : ans) {
    if (i < 0) {
      bs |= bs >> (-i);
    }
  }
  for (int i : a) {
    if (i > 0 && !bs.test(i)) {
      inf.quitf(_wa, "%d cannot be constructed using given cards", i);
    }
  }
  bs.reset();
  bs.set(0, true);
  for (int i : ans) {
    if (i < 0) {
      bs |= bs << (-i);
    }
  }
  for (int i : ans) {
    if (i > 0) {
      bs |= bs >> i;
    }
  }
  for (int i : a) {
    if (i < 0 && !bs.test(-i)) {
      inf.quitf(_wa, "%d cannot be constructed using given cards", i);
    }
  }
}

int main(int argc, char** argv) {
  registerTestlibCmd(argc, argv);
  int n = inf.readInt(1, N);
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    a[i] = inf.readInt();
  }
  int ans1 = ouf.readInt(0, 100000);
  int ans2 = ans.readInt(0, 100000);
  if (ans2 < ans1) {
    quitf(_wa, "Contestant has worse answer than jury: %d expected, but %d found", ans1, ans2);
  }
  for (int i = 0; i <= Q; i++) {
    pw.insert(1 << i);
    pw.insert(-(1 << i));
  }
  validateAnswer(ans1, ouf, a);
  validateAnswer(ans2, ans, a);
  if (ans1 < ans2) {
    quitf(_fail, "Contestant has better answer than jury: %d expected, but %d found. We're all doomed!!!!");
  }
  quitf(_ok, "Ok: %d", ans1);
}
