#include <cstdio>
#include <cassert>
#include <tuple>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;

vector<int> A;
const int Q = 10;
bitset<(2 << Q) + 1> can;
bitset<(2 << Q) + 1> need;

bool check(int q, int mskp, int mskn) {
    int off = 1 << Q;
    can.reset();
    can[off] = 1;
    for (int i = 0; i < q; i++) {
        int pw = 1 << i;
        if ((mskn >> i) & 1) {
            can |= can >>  pw;
        }
        if ((mskp >> i) & 1) {
            can |= can << pw;
        }
    }
    return (need & can) == need;
}

int main() {
    int n;
    scanf("%d", &n);
    A.resize(n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        scanf("%d", &A[i]);
        mx = max(mx, abs(A[i]));
        need[(1 << Q) + A[i]] = 1;
    }

    int q = 0;
    while ((1 << q) < mx) {
        ++q;
    }
    ++q;
    assert(q <= Q);

    tuple<int, int, int> ans(10000, 0, 0);

    for (int mskp = 0; mskp < (1 << q); ++mskp) {
        for (int mskn = 0; mskn < (1 << q); ++mskn) {
            auto result = __builtin_popcount(mskp) + __builtin_popcount(mskn);
            if (result < get<0>(ans) && check(q, mskp, mskn)) {
                ans = min(ans, make_tuple(result, mskp, mskn));
            }
        }
    }
    printf("%d\n", get<0>(ans));
    for (int i = 0; i < q; i++) {
        if ((get<1>(ans) >> i) & 1) {
            printf("%d ", 1 << i);
        }
        if ((get<2>(ans) >> i) & 1) {
            printf("%d ", -(1 << i));
        }
    }
    printf("\n");
}
